--Textured Polygon Demo - using xXxMoNkEyMaNxXx's PixelEffect
local sin, cos, atan2, sqrt, pi, floor = math.sin, math.cos, math.atan2, math.sqrt, math.pi, math.floor
local random, max, min = math.random, math.max, math.min
local gr, time, ky = love.graphics, love.timer, love.keyboard

local tex = require 'textured_quad'

-- NOTE: Love's coordinate system used exclusively ("So annoying").

function love.load()
	width, height = gr.getWidth(), gr.getHeight()
	gr.setBackgroundColor( 55, 55, 255, 255 )
	gr.setCaption( 'Quad Texturing Effect Test' )
	tex.load()
	-- load textures --
	image 	= gr.newImage( 'lenaC.jpg' )
	brick	= gr.newImage( 'brick.jpg' )
	fl00r	= gr.newImage( 'Checkerboard.jpg' )
	clouds	= gr.newImage( 'clouds.jpg' )
	-- create wall geometry --
	local outer = {   0,   0, 500, 500 }	-- outer room dims
	local inner = { 200, 200, 300, 300 }	-- room center cavity
	wall = createWalls( outer, inner )
	-- draw to canvas --
	canvas	= gr.newCanvas( 500, 500 )
	tex.effect.send ( tex.effect, "SIZEY", 500 )	-- must be set to canvas size
	gr.setCanvas( canvas )
		canvas:clear( 0,0,0, 0 )
		tex.quad( brick,	wall[1] )
		tex.quad( brick,	wall[2] )
		tex.quad( clouds,	wall[3] )
		tex.quad( fl00r,	wall[4] )
		tex.quad( image,	wall[5] )
		gr.setCanvas()
	tex.effect.send ( tex.effect, "SIZEY",gr.getHeight())	-- reset to screen size
	-- star code --
	star	= gr.newImage( 'StarTran.png' )
	fig = {
		sides	= 4,
		angle	= 0,
		size	= 200,
		center	= { x = width / 2, y = height / 2 }
		}
	sqr = create_quad( fig )
	scale_canvas = 0.1
	dir		= 1
	end

function love.draw()
	gr.setColor( 255, 255, 255, 255 )
	gr.draw( canvas, 400, 300, ang, scale_canvas, scale_canvas, 250, 250 )
	gr.setColor( 255, 255, 0, 255 )
	gr.print( 'fps: '..time.getFPS( ), width-100, height-20 )
	gr.setColor( 255, 255, 255, 0 )
	tex.quad( star, sqr )
	end

function love.keypressed( key )
	if key == "escape" then love.event.quit()	end
	end

function love.update( dt )
	scale_canvas  = scale_canvas + dir * dt
	if scale_canvas > 5   then dir = - dir scale_canvas = scale_canvas - 0.01 end
	if scale_canvas < 0.1 then dir = - dir scale_canvas = scale_canvas + 0.01 end
	fig.angle=fig.angle + dt
	sqr = create_quad( fig )
	end

function createWalls( o, i )	-- wall quads
	local w = {}
	w[1] = { {o[1],o[2]}, {o[1],o[4]}, {i[2],i[4]}, {i[2],i[2]} }
	w[2] = { {o[3],o[4]}, {o[3],o[2]}, {i[3],i[2]}, {i[3],i[4]} }
	w[3] = { {o[1],o[2]}, {o[3],o[2]}, {i[3],i[2]}, {i[1],i[2]} }
	w[3] = { {o[1],o[2]}, {i[1],i[2]}, {i[3],i[2]}, {o[3],o[2]} }
	w[4] = { {i[1],i[4]}, {o[1],o[4]}, {o[3],o[4]}, {i[3],i[4]} }
	w[5] = { {i[1],i[2]}, {i[1],i[4]}, {i[3],i[4]}, {i[3],i[2]} }
	return w
	end

function create_quad( obj )
	local angle_step	= 360/obj.sides
	local poly			= {}
	for side			= 1, obj.sides do
		poly[side]		= {}
		poly[side][1]	= floor(obj.size*sin((angle_step*(side-1)+obj.angle) * pi / 180+obj.angle) / 2+obj.center.x)
		poly[side][2]	= floor(obj.size*cos((angle_step*(side-1)+obj.angle) * pi / 180+obj.angle) / 2+obj.center.y)
		end
	return poly
	end
