-- trxture_effect.lua

local texture = {}
local gr = love.graphics
--[[Modifications:
		Love coordinate system used
		Texture info provided in table or as an image
		If only image provided, full texture used
		--]]

function texture.load()
texture.effect = gr.newPixelEffect[[
	//Made by xXxMoNkEyMaNxXx

	extern Image img;
	extern vec2 v1, v2, v3, v4;
	extern vec2 p0, rep;

	extern number SIZEY;//So annoying

	vec2 one=vec2(1,1);

	number c(vec2 v1,vec2 v2)
		{ return v1.x*v2.y-v2.x*v1.y; }
	number intersect(vec2 v1,vec2 d1,vec2 v2,vec2 d2)
		{ return c(v2-v1,d2)/c(d1,d2); }
	vec4 mask(vec4 base,vec4 over)
		{ return vec4(over.rgb*over.a+base.rgb*(1-over.a),over.a+base.a*(1-over.a)); }
	vec4 effect(vec4 colour,Image UNUSED1,vec2 UNUSED2,vec2 inverted)
		{
		vec2 p=vec2(inverted.x,SIZEY-inverted.y);//SO ANNOYING

		vec2 A1=normalize(v2-v1);
		vec2 A2=normalize(v3-v4);

		vec2 B1=normalize(v2-v3);
		vec2 B2=normalize(v1-v4);

		number Adiv=c(A1,A2);
		number Bdiv=c(B1,B2);

		vec2 uv;

		bvec2 eq0=bvec2(abs(Adiv)<=0.0001,abs(Bdiv)<=0.0001);
		if(eq0.x && eq0.y)
			{
			//Both edges are parallel, therefore the shape is a parallelogram (Isometric)
			number dis=dot(p-v1,A1);

			//cos theta
			number ct=dot(A1,B1);

			//Closest point on v1->A1 to p
			vec2 pA=v1+A1*dis;

			//uv
			number r=length(p-pA)/sqrt(1-ct*ct);
			uv=vec2(1-r/length(v2-v3),(dis+r*ct)/length(v2-v1));
			}
			else if(eq0.x)
			{
			//One Vanishing point occurs in numerically set scenarios in 3D, and is a feature of 2.5D

			//Horizon is A1 (=A2) from B
			vec2 Vp=v3+B1*c(v4-v3,B2)/Bdiv;

			//Some point in the distance that diagonals go to
			vec2 D=Vp+A1*intersect(Vp,A1,v4,normalize(v2-v4));

			//uv
			number u=intersect(v1,A1,Vp,normalize(p-Vp));
			number v=intersect(v1,A1,D,normalize(p-D))-u;

			number len=length(v2-v1);
			uv=vec2(len-v,u)/len;//Reversed components to match up with other one
			}
			else if(eq0.y)
			{
			//If the other edge is the parallel one
			vec2 Vp=v1+A1*c(v4-v1,A2)/Adiv;
			vec2 D=Vp+B1*intersect(Vp,B1,v4,normalize(v2-v4));
			number u=intersect(v3,B1,Vp,normalize(p-Vp));
			number len=length(v2-v3);
			uv=vec2(u,len-intersect(v3,B1,D,normalize(p-D))+u)/len;
			}
			else
			{
			//Else, two vanishing points

			//Vanishing points
			vec2 A=v1+A1*c(v4-v1,A2)/Adiv;
			vec2 B=v3+B1*c(v4-v3,B2)/Bdiv;

			//Horizon
			vec2 H=normalize(A-B);

			//Pixel
			uv=vec2(intersect(v4,-H,A,normalize(p-A))/intersect(v4,-H,v2,-A1),intersect(v4,H,B,normalize(p-B))/intersect(v4,H,v2,-B1));
			}
		return mask( colour, Texel( img, mod( uv*rep + vec2( p0.x-1, p0.y ), one ) ) );
		}
	]]

	texture.effect.send ( texture.effect, "SIZEY",	gr.getHeight() )--So annoying
	end
--------------------------------------------------------------
function texture.update( t,v)-- texture & quad
	--[[
	po  = {0,0}	-- origin {x,y} of texture as a fraction of the texture image
	rep = {1,1}	-- size   {w,h} of texture as a fraction of the texture image
	v must be a convex quad
	t can be an image or a table (containing image & portion of tex to be used ]]
	local po, rep
	if type( t ) == 'table' then
		img		= t.image
		t.sw	= img:getWidth()
		t.sh	= img:getHeight()
		if t.x and t.y and t.w and t.h then
			po  = { t.x / t.sw, t.y / t.sh }
			rep = { t.w / t.sw, t.h / t.sh }
			else
			op  = { 0, 0 }
			rep = { 1, 1 }
			end
		else
		img = t
		po  = { 0, 0 }
		rep = { 1, 1 }
		end

	texture.effect.send ( texture.effect, "img",	img  )
	texture.effect.send ( texture.effect, "v1",		v[4] )
	texture.effect.send ( texture.effect, "v2",		v[3] )
	texture.effect.send ( texture.effect, "v3",		v[2] )
	texture.effect.send ( texture.effect, "v4",		v[1] )
	texture.effect.send ( texture.effect, "p0",     po   )
	texture.effect.send ( texture.effect, "rep",    rep  )
	end

function texture.quad( t, v )
	texture.update( t, v )
	gr.setPixelEffect( texture.effect )
	gr.quad('fill',v[1][1],v[1][2],v[2][1],v[2][2],v[3][1],v[3][2],v[4][1],v[4][2])
	gr.setPixelEffect()
	end

return texture
